#include <stdio.h>
#include <System.h>

using System::IO::File;
using namespace System::IO::FileStream_ns;
using System::RunTime::Array;
using System::RunTime::MutableArray;


namespace Stuff {
	using System::Notifiers::Notifier;

class FileStream {
	File f;
	uint64_t pos;

public:
#include "server/c++/Stuff/FileStream.h"
//#include "sample-cpp-server-decl.h"

	FileStream()
	{
		init_iface();
	}

	void set_file(File F)
	{
		using System::IO;
		printf("this is %p\n", this);
		IO::FileStream fs = *this;
		IO::IOStream ostr = fs;
		IO::FileStream fs2 = IO::FileStream::downcast(ostr);
		printf("classptr is %p/%p\n", classptr(fs), classptr(fs2));
	
		if (!F)
			printf("File is NULL\n");
		else
			printf("File is not NULL\n");
			
		f = F;
	}
	
	void get_file(File *F)
	{
		*F = f;
	}
	
	void seek(int64_t offset, SeekType type)
	{
		if (!f) {
			// FIXME: Add a constructor to structs
			System::Exceptions::Std::InvalidState err;
			throw err;
		}
	
		switch (type) {
			case SeekType::FromBeginning:
				pos = offset;
				break;
			
			case SeekType::FromCurrent:
				pos += offset;
				break;
			
			case SeekType::FromEnd:
				f.size(&pos);
				pos += offset;
				break;
		}
	}
	
	void get_pos(uint64_t *POS)
	{
		*POS = pos;
	}

	void size(uint64_t *size)
	{
		f.size(size);
	}
	
	void read(Array<uint8_t> *buf, uint64_t *len)
	{
		if (!f) {
			// throw exc
			return;
		}
	
		f.read(pos, buf, len);
		pos += *len;
	}

	void read_foo(MutableArray<uint8_t> buf, uint64_t len, Notifier n)
	{
		if (!f) {
			// throw exc
			return;
		}
	
		f.read_async(pos, buf, len, n);
		pos += len;
	}

	void write(Array<uint8_t> buf, uint64_t *len)
	{
		if (!f) {
			// throw exc
			return;
		}
	
		f.write(pos, buf, len);
		pos += *len;
	}

	void write_foo(Array<uint8_t> buf, uint64_t len, Notifier n)
	{
		printf("write_foo, this %p\n", this);
	
		if (!f) {
			// throw exc
			return;
		}
	
		f.write_async(pos, buf, len, n);
		pos += len;
	}
	
	void new_timer(::System::Time::Timer *timer)
	{
	}
};
}

//#include "sample-cpp-server-footer.cc"
#include "server/c++/footer.cc"

#if 0
const unsigned long System::IO::_i_IOStream::guid[4] = { 1 };
const unsigned long System::IO::_i_IStream::guid[4] = { 2 };
const unsigned long System::IO::_i_OStream::guid[4] = { 3 };
const unsigned long System::IO::_i_FileStream::guid[4] = { 4 };
const unsigned long System::_i_Object::guid[4] = { 5 };
#endif

int main()
{
	Stuff::FileStream *fsimp = new Stuff::FileStream();
	System::IO::FileStream fs = *fsimp;

	if (!fs)
		printf("fs is NULL\n");
	else {
		printf("fs is not NULL\n");
		fs.set_file(NULL);
	}
	
	printf("fs is %p\n", (void *)fs);
	fs.write_async(Array<uint8_t>(NULL, 0), 0, NULL);
	printf("fs is %p\n", (void *)fs);
	System::IO::OStream ostr = fs;
	printf("ostr is %p\n", (void *)ostr);
	ostr.write_async(Array<uint8_t>(NULL, 0), 0, NULL);
	System::Object obj = fs;
	System::IO::FileStream fs2 = System::IO::FileStream::downcast(obj);
	System::IO::OStream os2 = System::IO::OStream::downcast(obj);
	printf("obj %p fs2 %p os2 %p\n", (void *)obj, (void *)fs2, (void *)os2);
	
	return 0;
}
