#ifndef _LL_ARCH_ATOMIC_H
#define _LL_ARCH_ATOMIC_H

#include <lowlevel/arch-x86-common/atomic.h>

static inline int ll_cmpxchg_long(unsigned long *val, unsigned long oldval,
                                  unsigned long newval)
{
	int ret;

	if (_LL_SMP)
		asm("lock; cmpxchgq %0, %1; setz %b1" :
		    "+m" (*val) : "r" (newval), "a" (oldval) : "memory");
	else
		asm("cmpxchgq %0, %1; setz %b1" :
		    "+m" (*val) : "r" (newval), "a" (oldval) : "memory");

	return ret;
}

static inline unsigned long ll_xchg_long(unsigned long *ptr,
                                         unsigned long val)
{
	asm("xchgq %0, %1" : "+r" (val), "+m" (*ptr));
	return val;
}

#endif
