// Memory and I/O barriers.  These are not privileged.

#ifndef _LL_ARCH_X86C_BARRIERS_FENCE_H
#define _LL_ARCH_X86C_BARRIERS_FENCE_H

#include <lowlevel/types.h>

static inline void ll_membar()
{
	asm volatile("mfence" : : : "memory");
}

static inline void ll_membar_load_after_load()
{
	asm volatile("lfence" : : : "memory");
}

static inline void ll_membar_load_after_store()
{
	ll_membar();
}

static inline void ll_membar_load_after_any()
{
	ll_membar();
}

static inline void ll_membar_any_after_load()
{
	ll_membar();
}

static inline void ll_membar_store_after_load()
{
	ll_membar();
}

static inline void ll_membar_store_after_store()
{
	asm volatile("sfence" : : : "memory");
}

static inline void ll_membar_store_after_any()
{
	ll_membar();
}

static inline void ll_membar_any_after_store()
{
	ll_membar();
}

static inline void ll_smp_membar()
{
	if (_LL_SMP)
		ll_membar();
	else
		ll_barrier();
}

static inline void ll_smp_membar_load_after_load()
{
	if (_LL_SMP)
		ll_membar_load_after_load();
	else
		ll_barrier();
}

static inline void ll_smp_membar_load_after_store()
{
	ll_smp_membar();
}

static inline void ll_smp_membar_load_after_any()
{
	ll_smp_membar();
}

static inline void ll_smp_membar_any_after_load()
{
	ll_smp_membar();
}

static inline void ll_smp_membar_store_after_load()
{
	ll_membar();
}

static inline void ll_smp_membar_store_after_store()
{
	if (_LL_SMP)
		ll_membar_store_after_store();
	else
		ll_barrier();
}

static inline void ll_smp_membar_store_after_any()
{
	ll_smp_membar();
}

static inline void ll_smp_membar_any_after_store()
{
	ll_smp_membar();
}

#endif
