#ifndef _KERN_ASSERT_H
#define _KERN_ASSERT_H

#include <kern/conf.h>
#include <kern/libc.h>

namespace Assert
{
	static inline __attribute__((noreturn))
	void assert_failure(const char *file, int line)
	{
		printf("Assertion failure at %s:%d\n", file, line);
		__builtin_trap();
	}
}

#include <util/assert.h>
#define assert(cond) assertl(cond, Assert::Normal)

#endif
