#include <System.h>

namespace System {
	namespace RunTime {
		// This function could be made to do a binary search if we can
		// manage to somehow sort the IFaceTables...

		uintptr_t downcast(::System::_i_Object *obj,
		                   const unsigned long *new_guid)
		{
			if (!obj)
				return 0;

			void unsupported_long_size();

			if (sizeof(long) != 4 && sizeof(long) != 8)
				unsupported_long_size();

			IFaceTable *tbl = obj->info->concrete_IFaceTable;
			unsigned long new_guid_first = *new_guid;
			
			// This doesn't use guids_equal(), as that would eliminate the
			// ability to cache the first word of new_guid.  The compiler
			// *might* do it anyway, but this code was written before
			// guids_equal existed, and I don't want to risk removing an
			// optimization by changing it now without testing how GCC
			// behaves.
			
			do {
				if (*tbl->guid == new_guid_first &&
				    tbl->guid[1] == new_guid[1] &&
				    (sizeof(long) == 8 ||
				     (tbl->guid[2] == new_guid[2] &&
				      tbl->guid[3] == new_guid[3])))
					break;				

				tbl++;
			} while (tbl->guid);
			
			uintptr_t ptr = reinterpret_cast<uintptr_t>(obj);
			
			ptr += obj->info->concrete;
			ptr += tbl->offset;
			
			return ptr;
		};
		
		unsigned long get_pc()
		{
			return reinterpret_cast<unsigned long>(__builtin_return_address(0));
		}
	}
}
